/***********************************************************
        	      (C) Copyright 1993
		Curtin University of Technology
		    Perth Western Australia



 This software is provided as is without any warranty express
 or implied.  Curtin University make no representation as to its
 suitability for any purpose whatsoever.

 Permission to use, modify or copy this software and its
 documentation is hereby granted to the source license holder.
 It is an express condition of such permission that the user
 accepts all responsibility for the use of the software and
 further that:

 1.    this notice appears in any copies of the software and the
       supporting documentation; and

 2.    the name of Curtin University not be used in any
       advertising or publicity pertaining to the software nor
       used to endorse or promote any product derived from this
       software without prior specific written permission.

 3.    the software in source form may not be given to any
       party other than those listed on the source license.

******************************************************************/
static char sccsid[] = "@(#)types.c	1.4	6/10/93";

/*
 *
 */

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Xmu/CharSet.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Cardinals.h>
#include "types.h"
#include "macros.h"
extern void XmuConvertStringToWidget ();	/* original converter */

/*
 * Functions defined here:
 */
/*void initConverters();*/

Boolean cvtStringToFilterType (), cvtStringToTrafficType ();
Boolean cvtStringToMiscType (), cvtStringToHostsType ();
Boolean cvtStringToStatsType ();
void    cvtStringToWidget ();

void
initConverters (appContext)
XtAppContext appContext;
{
    static XtConvertArgRec parentCvtArgs[] = {
	{XtBaseOffset, (caddr_t) XtOffset (Widget, core.parent), sizeof (Widget)}
    };

    XtSetTypeConverter (XtRString, nm_RFilterType, cvtStringToFilterType,
	NULL, ZERO, XtCacheNone, NULL);
    XtSetTypeConverter (XtRString, nm_RTrafficType, cvtStringToTrafficType,
	NULL, ZERO, XtCacheNone, NULL);
    XtSetTypeConverter (XtRString, nm_RMiscType, cvtStringToMiscType,
	NULL, ZERO, XtCacheNone, NULL);
    XtSetTypeConverter (XtRString, nm_RHostsType, cvtStringToHostsType,
	NULL, ZERO, XtCacheNone, NULL);
    XtSetTypeConverter (XtRString, nm_RStatsType, cvtStringToStatsType,
	NULL, ZERO, XtCacheNone, NULL);

    /* Have to initialize Form class first or our converter will be	 */
    /* overidden by the class initialization function.			 */
    /* Use the old style here on purpose since that what the default is. */
    XtInitializeWidgetClass (formWidgetClass);
    XtAppAddConverter (appContext, XtRString, XtRWidget, cvtStringToWidget,
	parentCvtArgs, XtNumber (parentCvtArgs));
}

/* for each menu define options */

Boolean
cvtStringToFilterType (display, args, num_args, fromVal, toVal, data)
Display *display;
XrmValuePtr args;		       /* unused */
Cardinal *num_args;		       /* unused */
XrmValuePtr fromVal;
XrmValuePtr toVal;
XtPointer *data;		       /* unused */
{
    char    message[1000];

    XmuCopyISOLatin1Lowered (message, (char *) (fromVal->addr));
    if (strcmp (message, "all") == 0)
	done (nm_all, FilterType);
    if (strcmp (message, "ip") == 0)
	done (nm_IP, FilterType);
    if (strcmp (message, "udp") == 0)
	done (nm_UDP, FilterType);
    if (strcmp (message, "udpnfs") == 0)
	done (nm_UDPnfs, FilterType);
    if (strcmp (message, "udpdns") == 0)
	done (nm_UDPdns, FilterType);
    if (strcmp (message, "udprpc") == 0)
	done (nm_UDPrpc, FilterType);
    if (strcmp (message, "udptftp") == 0)
	done (nm_UDPtftp, FilterType);
    if (strcmp (message, "udprwho") == 0)
	done (nm_UDPrwho, FilterType);
    if (strcmp (message, "udpsyslog") == 0)
	done (nm_UDPsyslog, FilterType);
    if (strcmp (message, "udptalk") == 0)
	done (nm_UDPtalk, FilterType);
    if (strcmp (message, "udpntalk") == 0)
	done (nm_UDPntalk, FilterType);
    if (strcmp (message, "decnet") == 0)
	done (nm_DecNet, FilterType);
    if (strcmp (message, "lat") == 0)
	done (nm_LAT, FilterType);
    if (strcmp (message, "appletalk") == 0)
	done (nm_AppleTalk, FilterType);
    if (strcmp (message, "novell") == 0)
	done (nm_Novell, FilterType);
    if (strcmp (message, "custom") == 0)
	done (nm_custom, FilterType);
    if (strcmp (message, "tcpall") == 0)
	done (nm_TCPall, FilterType);
    if (strcmp (message, "tcpftp") == 0)
	done (nm_TCPftp, FilterType);
    if (strcmp (message, "tcptelnet") == 0)
	done (nm_TCPtelnet, FilterType);
    if (strcmp (message, "tcpsmtp") == 0)
	done (nm_TCPsmtp, FilterType);
    if (strcmp (message, "tcpsunrpc") == 0)
	done (nm_TCPsunrpc, FilterType);
    if (strcmp (message, "tcpfinger") == 0)
	done (nm_TCPfinger, FilterType);
    if (strcmp (message, "tcpnntp") == 0)
	done (nm_TCPnntp, FilterType);
    if (strcmp (message, "tcpx400") == 0)
	done (nm_TCPx400, FilterType);
    if (strcmp (message, "tcplpd") == 0)
	done (nm_TCPlpd, FilterType);
    if (strcmp (message, "tcpcustomport") == 0)
	done (nm_TCPcustomport, FilterType);
    XtDisplayStringConversionWarning (display, fromVal->addr, nm_RFilterType);
    toVal->addr = NULL;
    toVal->size = 0;
}
Boolean
cvtStringToTrafficType (display, args, num_args, fromVal, toVal, data)
Display *display;
XrmValuePtr args;		       /* unused */
Cardinal *num_args;		       /* unused */
XrmValuePtr fromVal;
XrmValuePtr toVal;
XtPointer *data;		       /* unused */
{
    char    message[1000];

    XmuCopyISOLatin1Lowered (message, (char *) (fromVal->addr));
    if (strcmp (message, "packets") == 0)
	done (nm_packets, TrafficType);
    if (strcmp (message, "bytes") == 0)
	done (nm_bytes, TrafficType);
    XtDisplayStringConversionWarning (display, fromVal->addr, nm_RTrafficType);
    toVal->addr = NULL;
    toVal->size = 0;
}
Boolean
cvtStringToMiscType (display, args, num_args, fromVal, toVal, data)
Display *display;
XrmValuePtr args;		       /* unused */
Cardinal *num_args;		       /* unused */
XrmValuePtr fromVal;
XrmValuePtr toVal;
XtPointer *data;		       /* unused */
{
    char    message[1000];

    XmuCopyISOLatin1Lowered (message, (char *) (fromVal->addr));
    if (strcmp (message, "postscript") == 0)
	done (nm_postscript, MiscType);
    if (strcmp (message, "summary") == 0)
	done (nm_summary, MiscType);
    if (strcmp (message, "reset") == 0)
	done (nm_reset, MiscType);
    if (strcmp (message, "broad") == 0)
	done (nm_broad, MiscType);
    XtDisplayStringConversionWarning (display, fromVal->addr, nm_RMiscType);
    toVal->addr = NULL;
    toVal->size = 0;
}
Boolean
cvtStringToHostsType (display, args, num_args, fromVal, toVal, data)
Display *display;
XrmValuePtr args;		       /* unused */
Cardinal *num_args;		       /* unused */
XrmValuePtr fromVal;
XrmValuePtr toVal;
XtPointer *data;		       /* unused */
{
    char    message[1000];

    XmuCopyISOLatin1Lowered (message, (char *) (fromVal->addr));
    if (strcmp (message, "ether") == 0)
	done (nm_ether, HostsType);
    if (strcmp (message, "ipaddr") == 0)
	done (nm_IPaddr, HostsType);
    if (strcmp (message, "localname") == 0)
	done (nm_localname, HostsType);
    if (strcmp (message, "manfcode") == 0)
	done (nm_manfcode, HostsType);
    XtDisplayStringConversionWarning (display, fromVal->addr, nm_RHostsType);
    toVal->addr = NULL;
    toVal->size = 0;
}
Boolean
cvtStringToStatsType (display, args, num_args, fromVal, toVal, data)
Display *display;
XrmValuePtr args;		       /* unused */
Cardinal *num_args;		       /* unused */
XrmValuePtr fromVal;
XrmValuePtr toVal;
XtPointer *data;		       /* unused */
{
    char    message[1000];

    XmuCopyISOLatin1Lowered (message, (char *) (fromVal->addr));
    if (strcmp (message, "dynamic") == 0)
	done (nm_dynamic, StatsType);
    if (strcmp (message, "cumulative") == 0)
	done (nm_cumulative, StatsType);
    XtDisplayStringConversionWarning (display, fromVal->addr, nm_RStatsType);
    toVal->addr = NULL;
    toVal->size = 0;
}

/*	-	-	-	-	-	-	-	-	*/
/*
 * cvtStringToWidget() : Allows us to specify "NULL" as a widget name in
 *	a resource file to override compiled-in defaults for composite
 *	widget layouts. Simply calls the regular converter if the string
 *	is not "NULL". Note that this must be registered *after* the
 *	Form class is initialized.
 */
void
cvtStringToWidget (args, num_args, fromVal, toVal)
XrmValuePtr args;
Cardinal *num_args;
XrmValuePtr fromVal;
XrmValuePtr toVal;
{
    if (XmuCompareISOLatin1 (fromVal->addr, "NULL") == 0) {
	toVal->addr = NULL;
	toVal->size = 0;
    }
    else {
	XmuCvtStringToWidget (args, num_args, fromVal, toVal);
    }
}
